// $Header: /home/anthony/tolkien/include/RCS/graycode.h,v 1.2 1996/06/19 02:19:53 anthony Exp $
//
//      TOLKIEN: Tool Kit for Genetics-based Applications
//
//      Anthony Yiu-Cheung Tang, 1992-93.
//      Department of Computer Science
//      The Chinese University of Hong Kong.
//
#if !defined ( __GRAYCODE_H )
#define __GRAYCODE_H

#include <tdefs.h>

class   GrayCode
{
public:
        GrayCode(unsigned = 8);
        ~GrayCode();

        unsigned long asGray(unsigned long);
        unsigned long asBin(unsigned long);
        unsigned long b2g(unsigned long, unsigned = LONGBITS);
        unsigned long g2b(unsigned long, unsigned = LONGBITS);

private:

        unsigned matsize;
        unsigned *pBG;   // binary to graycode
        unsigned *pGB;   // graycode to binary
};

inline GrayCode::~GrayCode()
{
	if (matsize > 0) {
            delete [] pBG;
            delete [] pGB;
        }
}

inline unsigned long GrayCode::asGray(unsigned long bits)
{
        if (bits < matsize)
            return pBG[bits];
        else
            if (bits > MAXINT)
                return g2b(bits, LONGBITS);
            else
                return g2b(bits, INTBITS);

}

inline unsigned long GrayCode::asBin(unsigned long bits)
{
	if (bits < matsize)
            return pGB[bits];
        else
            if (bits > MAXINT)
                return g2b(bits, LONGBITS);
            else
                return g2b(bits, INTBITS);
}

extern  GrayCode tGrayCode;

#endif

