// $Header: /home/anthony/tolkien/include/RCS/popsmpl.h,v 1.5 1996/06/19 02:19:53 anthony Exp $
//
//      TOLKIEN: Tool Kit for Genetics-based Applications
//
//      Anthony Yiu-Cheung Tang, 1992-93.
//      Department of Computer Science
//      The Chinese University of Hong Kong.
//
//      Anthony Yiu-Cheung Tang, 1996.
//
#if !defined( __POPSMPL_H)
#define     __POPSMPL_H

#include <populatn.h>
#include <ranksb.h>

template <class PhenotypeFunction, class Collection = vector<TGAObj*> > 
class SimplePopulation : public Population<PhenotypeFunction, Collection>
{
public:
        SimplePopulation() : 
             Population<PhenotypeFunction, Collection>()
        {
        }

        SimplePopulation(const SimplePopulation& src) :
               Population<PhenotypeFunction, Collection>(src)
        {
        }

        virtual void replace(vector<TGAObj*>& newInds, bool reEvaluate )
        //
        //      old individuals are replaced in a random manner
        //      it is assumed that newInds.size() <= Inds.size()
        //
        {
        	int i;
        	// generate a random subset of integers in [0,size() - 1]
                vector<int> ndx;
                ranksb.random(ndx, newInds.size() < inds.size() ?  
                              newInds.size() : inds.size(),inds.size());

        	if ( reEvaluate ) {
        	    //
        	    // all individuals are evaluated
        	    //
                    i = 0;
                    while ( (i < inds.size()) && (i < newInds.size()) ) {
                        delete inds[ndx[i]]; // delete old member first
		        inds[ndx[i]] = newInds[i];
                        i++;
	            }

                    for (i=0;i<inds.size();i++) 
	        	evaluate(inds[i]);
        	}
        	else {
        	    //
        	    // only new individuals are evaluated
        	    //
                    i = 0;
                    while ( (i < inds.size()) && (i < newInds.size()) ) {
	        	evaluate(newInds[i]);
                        delete inds[ndx[i]]; // delete old member first
        		inds[ndx[i]] = newInds[i];
                        i++;
        	    }
                }
        }
};

#endif

