// $Header: /home/anthony/tolkien/include/RCS/schemata.h,v 1.3 1996/06/19 02:19:53 anthony Exp $
//
//      TOLKIEN: Tool Kit for Genetics-based Applications
//
//      Anthony Yiu-Cheung Tang, 1992-93.
//      Department of Computer Science
//      The Chinese University of Hong Kong.
//
//      Anthony Yiu-Cheung Tang, 1992-96.
//
#if !defined( __SCHEMATA_H )
#define     __SCHEMATA_H

#include <binind.h>
#include <map.h>
#include <tritstr.h>
#include <populatn.h>

template <class Collection = vector<TGAObj*> >
class SchemataStatistics
{
public:
        virtual ~SchemataStatistics() { }
        virtual void reset()
        {
            map<TritString,int,less<TritString> >::iterator 
                  i = schemata.begin(), j = schemata.end();
            // schemata.erase(schemata.begin(),schemata.end());
        }
        virtual void operator()(const PopulationBase<Collection>& );
        virtual void add(const char * szString)
        {
            TritString t(szString);
	    schemata[t] = 0;
	}
	virtual void add(const TritString & tstr)
        {
	    schemata[tstr] = 0;
	}

	virtual int getCount(const TritString& schema) 
        {
            return schemata[schema];
        }

        int numSchemata() const
        {
            return schemata.size();
        }
 
        void printOn(ostream& out) const
        {
            for (map<TritString,int,less<TritString> >::const_iterator i = schemata.begin();
                 i != schemata.end();
                 i++) 
            {
	         (*i).first.printOn(out);
                 out << " : " << (*i).second << endl;
            }
        }

protected :
        map<TritString,int,less<TritString> > schemata;
};

template <class Collection>
void SchemataStatistics<Collection>::operator()(const PopulationBase<Collection>& pop)
//
//	This function assumes that the individuals of pop
//	are of the same species
//
{
        Collection::const_iterator ind;
        map<TritString,int,less<TritString> >::iterator schema = schemata.begin();

	while ( schema != schemata.end() ) {
		ind = pop.begin();
		(*schema).second = 0;
		while ( ind != pop.end() ) {
                    if ((*schema).first.matches(((const BinIndividual*) *ind)->asBitString())) 
                        (*schema).second += 1;
                    ind++;
                }
		schema++;
         }
}

#endif

