// $Header: /home/anthony/tolkien/include/RCS/select.h,v 1.2 1996/06/19 02:19:53 anthony Exp $
//
//      TOLKIEN: Tool Kit for Genetics-based Applications
//
//      Anthony Yiu-Cheung Tang, 1992-93.
//      Department of Computer Science
//      The Chinese University of Hong Kong.
//
//      Anthony Yiu-Cheung Tang, 1996.
//
#if !defined( __SELECT_H )
#define     __SELECT_H

template <class Collection = vector<TGAObj*> > class PopulationBase;

template<class Collection = vector<TGAObj*> >
class  SelectionScheme
{
public:
        virtual ~SelectionScheme() { }
        virtual const TGAObj* select() = 0;
        virtual void init() = 0;
        void selectOn(PopulationBase<Collection>& src)
        {
                pPop = (PopulationBase<Collection>*) &src;
                init();
        }
        long total() const { return nSelected; }

protected:
        PopulationBase<Collection>* pPop;
        int nSelected;

        SelectionScheme() : nSelected(0), pPop(NULL) { }
        void count() { nSelected++; }
};

#endif

