// $Header: /home/anthony/tolkien/include/RCS/slcttour.h,v 1.4 1996/06/19 02:19:53 anthony Exp $
//
//      TOLKIEN: Tool Kit for Genetics-based Applications
//
//      Anthony Yiu-Cheung Tang, 1992-93.
//      Department of Computer Science
//      The Chinese University of Hong Kong.
//
//      Anthony Yiu-Cheung Tang, 1996.
//
#if !defined(__SLCTTOUR_H)
#define __SLCTTOUR_H

#include <populatn.h>
#include <set.h>
#include <vector.h>
#include <ranksb.h>

template <class Collection = vector<TGAObj*> >
class  TournSelect : public SelectionScheme<Collection>
{
public:
	TournSelect(int size = 2) 
        {
             players.reserve(rangeCheck(size,2,(int)(size/2.0),2));
        }

	~TournSelect() {}

        void init()
        {
        }

	const TGAObj* select()
        {
            Collection::iterator pWinner, pObj;
            ranksb.random(players, players.capacity(), pPop->popSize());
            pWinner = pPop->begin() + players[0];
            for (int i = 1; i < players.capacity(); i++) {
                pObj = pPop->begin() + players[i];
                if ((*pWinner)->fitness() < (*pObj)->fitness())
                    pWinner = pObj;
            }
            
            count();
            return *pWinner;
        }

protected:
        vector<int> players;
};

#endif


