// $Header: /home/anthony/tolkien/src/RCS/xover.cc,v 1.3 1996/06/19 02:24:55 anthony Exp $
//
//      TOLKIEN: Tool Kit for Genetics-based Applications
//
//      Anthony Yiu-Cheung Tang, 1992-93.
//      Department of Computer Science
//      The Chinese University of Hong Kong.
//

#include <xover.h>
#include <trand.h>
// #include <tbitstr.h>
// #include <tritstr.h>
#include <vector.h>

TGAObj* UniformCrossover::create()
{
        const TGAObj* pTmp = pFather;
	TGAObj*  pChild = pMother->uniformCrossover(pFather, flXRate);
	// swap parents
	pFather = pMother;
	pMother = pTmp;

	count(); 

        return pChild;
}

MultiPtCrossover::MultiPtCrossover(unsigned uPoints, double flRate)
{
        if (uPoints % 2 == 0)
            pXOver = new EvenPtCrossover(uPoints, flRate);
        else
            pXOver = new OddPtCrossover(uPoints, flRate);
}

void MultiPtCrossover::xpts(unsigned uNewPts)
{
	unsigned nOldXpts = pXOver->xpts();
	double flRate = pXOver->rate();
	const TGAObj *pInd1, *pInd2;

        if (pXOver->xpts() % 2 == 0) {
            if (uNewPts % 2 == 0)
                pXOver->xpts(uNewPts);
            else {
	        pXOver->getMates(pInd1, pInd2);
                delete pXOver;
                pXOver = new OddPtCrossover(uNewPts, flRate);
		pXOver->setMates(pInd1, pInd2);
            }
        }
        else {
            if (uNewPts % 2 != 0)
                pXOver->xpts(uNewPts);
            else {
	        pXOver->getMates(pInd1, pInd2);
                delete pXOver;
                pXOver = new EvenPtCrossover(uNewPts, flRate);
		pXOver->setMates(pInd1, pInd2);
            }
        }
}

TGAObj* EvenPtCrossover::create() 
{
        const TGAObj* pTmp = pFather;
	TGAObj*  pChild;

        if (flip())
            pChild = pMother->evenPtCrossover(pFather, nXpts);
        else
	    pChild = pMother->clone();
	// swap parents
	pFather = pMother;
	pMother = pTmp;

	count(); 

        return pChild;
}

TGAObj* OddPtCrossover::create()
{
        const TGAObj* pTmp = pFather;
	TGAObj*	pChild;

        if (flip())
            pChild = pMother->oddPtCrossover(pFather, nXpts);
        else
	    pChild = pMother->clone();
	// swap parents
	pFather = pMother;
	pMother = pTmp;

	count(); 

	return pChild;
}

